<template>
  <div class="top_header">
    <div class="text_head">
      <h2>Results</h2>
    </div>

    <div class="search_head">
      <input
        class="search"
        placeholder="Search by result, date"
        v-model="search"
      />
    </div>

    <div class="select_head">
      <select class="select" v-model="key">
        <option value="">All</option>
        <option value="Calculator A">Calculator A</option>
        <option value="Calculator B">Calculator B</option>
      </select>
    </div>
  </div>

  <div class="box">
    <div class="content" id="display">
      <div class="container">
        <div v-for="d in filterHistory" v-bind:key="d">
          <h2 class="calName">{{ d.name }}</h2>
          <h2 class="Date">{{ d.date }}</h2>
          <h1 class="result">{{ d.result }}</h1>
          <h2 class="formula">{{ d.formula }}</h2>
          <br />
        </div>
        <div v-if="filterHistory === null">
          <h2 class="show-text-when-null">{{ ms }}</h2>
        </div>
      </div>
      <button class="clear" @click="onClear()">Clear</button>
    </div>
  </div>
</template>

<script>
export default {
  name: "CalculatorResult",
  data() {
    return {
      key: "",
      search: "",
      ms: "There's no history yet"
    };
  },
  computed: {
    filterHistory() {
      if (JSON.parse(localStorage.getItem("historyList"))) {
        return this.$store.state.dataLocal.filter((history) => {
          if (document.getElementById("display")) {
            const objDiv = document.getElementById("display");
            setTimeout(function () {
              objDiv.scrollTo(0, objDiv.scrollHeight);
            }, 0);
          }
          return (
            (history.result.toString().match(this.search) ||
              history.date.toString().match(this.search)) &&
            history.name.toString().match(this.key)
          );
        });
      } else {
        return this.$store.state.dataLocal;
      }
    },
  },
  methods: {
    onClear() {
      if (confirm("Do you want to clear all history?")) {
        localStorage.clear();
        this.$store.state.dataLocal = null;
      }
    },
  },
};
</script>

<style scoped>
.top_header {
  display: flex;
  align-items: baseline;
}

.text_head {
  float: left;
  width: 20%;
  color: #707070;
}
h2 {
  font-weight: 400;
}

.search_head {
  float: left;
  width: 60%;
}

.select_head {
  float: left;
  width: 20%;
}

.search,
.select {
  width: 95%;
  border-radius: 13px;
  border-color: #c9c9c9;
  height: 40px;
  border-width: thin;
  box-shadow: 0 2px 5px -1px rgba(0, 0, 0, 0.25);
  font-size: x-large;
  border-style: none;
  color: #707070;
}
.search {
  width: 90%;
  padding-left: 5%;
}

select {
  text-align: center;
  text-align-last: center;
}

@media screen and (max-width: 540px) {
  .top_header{
    display: flex;
    flex-direction: column;
  }

  .text_head,
  .search_head,
  .select_head {
    float: left;
    width: 100%;
    /* The width is 100%, when the viewport is 800px or smaller */
  }
  .search_head,
  .select_head {
    margin-bottom: 2%;
  }
  .Date {
    color: #9ac2e3;
    font-weight: 400;
    float: right;
    width: 50%;
  }
}

.box {
  float: left;
  width: 100%;
  height: 600px;
  border-radius: 20px;
  position: relative;
  background-color: white;
}

.content {
  overflow: auto;
  width: 100%;
  height: 100%;
  -ms-overflow-style: none;
  /* IE and Edge */
  scrollbar-width: none;
  /* Firefox */
}

/* Hide scrollbar for Chrome, Safari and Opera */

*::-webkit-scrollbar {
  display: none;
}

.container {
  padding: 7%;
}

button {
  position: absolute;
  bottom: 1.5rem;
  right: 1.5rem;
  border-radius: 13px;
  background-color: #faa7a7;
  border-color: #faa7a7;
  color: white;
  font-size: x-large;
  padding: 3px 10px;
  border-style: hidden;
  width: 14%;
  height: 10%;
}

@media screen and (max-width: 700px) {
  .clear {
    width: 30%;
  }
}

.calName {
  color: #707070;
  font-weight: 400;
  float: left;
  width: 60%;
}

.Date {
  color: #9ac2e3;
  font-weight: 400;
  float: right;
  width: 40%;
}

.result {
  /* font-size: calc(1.375rem + 2vw); */
  font-size: revert;
  font-weight: 400;
  color: #707070;
  overflow: auto;
  float: left;
  width: 100%;
  -ms-overflow-style: none;
  /* IE and Edge */
  scrollbar-width: none;
  /* Firefox */
}
.container h1 {
  margin: 0%;
}
.container h2 {
  margin: 0%;
}

.formula {
  color: #707070;
  overflow: auto;
  white-space: nowrap;
  border-top: 1px solid #cbcbcb;
  float: left;
  width: 100%;
}

.container .formula {
  margin-bottom: 5%;
}
</style>
